import "./style.css";
import { reactive as B, computed as F, onActivated as z, watch as G, ref as H, resolveComponent as p, openBlock as Y, createBlock as j, withCtx as w, createVNode as h, normalizeClass as J, createElementVNode as _, toDisplayString as K, withDirectives as k, vShow as T } from "vue";
import { Grid as Q, GridColumn as W } from "@opentiny/vue";
import { PluginPanel as X, SvgButton as Z } from "@opentiny/tiny-engine-common";
import { constants as $ } from "@opentiny/tiny-engine-utils";
import { iconEyeopen as ee, iconEyeclose as te, IconChevronDown as oe } from "@opentiny/vue-icon";
import { useCanvas as m, useMaterial as ne, useLayout as D } from "@opentiny/tiny-engine-meta-register";
import { extend as re } from "@opentiny/vue-renderless/common/object";
import { typeOf as ce } from "@opentiny/vue-renderless/common/type";
const se = (c, i) => {
  const d = c.__vccOpts || c;
  for (const [n, f] of i)
    d[n] = f;
  return d;
}, { PAGE_STATUS: q } = $, ae = {
  components: {
    TinyGrid: Q,
    TinyGridColumn: W,
    PluginPanel: X,
    SvgButton: Z,
    IconEyeopen: ee(),
    IconEyeclose: te()
  },
  props: {
    fixedPanels: {
      type: Array
    }
  },
  emits: ["close", "fix-panel"],
  setup() {
    const { pageState: c, getInstance: i } = m(), { getMaterial: d } = ne(), n = (e) => {
      const o = (s) => (s.forEach((a) => {
        a.show = c.nodesStatus[a.id] !== !1;
        const y = a.children;
        ce(y) !== "array" ? delete a.children : a.children.length && o(a.children);
      }), s);
      return [{ ...o([re(!0, {}, e)])[0], componentName: "body" }];
    }, { PLUGIN_NAME: f } = D(), t = B({
      pageSchema: [],
      expandAll: !0,
      initSchema: [],
      isLock: F(
        () => ![q.Occupy, q.Guest].includes(D().layoutState.pageStatus.state)
      ),
      dragState: {
        allowDrop: !0,
        dragSchema: null,
        hoverVm: null,
        currentVm: null,
        parentNode: null,
        indicator: !0
      }
    });
    z(() => {
      const { getSchema: e } = m().canvasApi.value;
      t.pageSchema = n(e());
    }), G(
      () => c.currentSchema,
      () => {
        const { getSchema: e } = m().canvasApi.value;
        t.pageSchema = n(e());
      }
    );
    const N = () => {
      t.expandAll = !t.expandAll;
    }, A = (e) => {
      e.show = !e.show, c.nodesStatus[e.id] = e.show;
      const { getRenderer: o, clearSelect: s } = m().canvasApi.value;
      o().setCondition(e.id, e.show), s();
    }, b = (e) => e.componentName ? d(e.componentName).icon || "IconAssociation" : void 0, x = (e, o) => {
      if (t.isLock)
        return;
      const { hoverNode: s } = m().canvasApi.value;
      s(e.id);
      const a = o.target.querySelector(".tree-handle");
      a && (a.style.display = "block");
    }, I = (e, o) => {
      e && !e.show || (o.target.querySelector(".tree-handle").style.display = "none");
    }, L = (e) => {
      if (t.isLock)
        return;
      const { selectNode: o } = m().canvasApi.value;
      o(e == null ? void 0 : e.id, "clickTree");
    }, r = H(null), u = () => {
    }, l = ({ row: e }) => {
      var s;
      return "nav-tree " + (((s = c == null ? void 0 : c.currentSchema) == null ? void 0 : s.id) === e.id ? "high-light-node" : "");
    }, O = (e, o) => {
      var P;
      e.dragged.classList.remove("nodrag");
      const { clientY: s } = o, a = e.draggedRect.bottom, y = Math.abs(s - a), M = e.dragged.querySelector(".tree-box").getAttribute("type"), R = e.dragged.querySelector(".tree-box").getAttribute("schemaId"), S = i(R);
      t.dragState.dragSchema = S;
      const E = e.related.querySelector(".tree-box").getAttribute("type"), U = e.related.querySelector(".tree-box").getAttribute("schemaId"), g = i(U);
      c.hoverVm = g;
      const v = (P = S == null ? void 0 : S.componentName) == null ? void 0 : P.container, V = g == null ? void 0 : g.parent.schema.componentName;
      M === "col" && v && E !== "col" || M === "col" && !v && V !== "row" || M !== "col" && v && E === "row" ? t.dragState.indicator = !1 : g ? t.dragState.indicator = !0 : t.dragState.indicator = !1, t.dragState.indicator ? (e.dragged.classList.remove("nodrag"), t.dragState.allowDrop = !0) : (e.dragged.classList.add("nodrag"), t.dragState.allowDrop = !1);
      const C = o.target;
      y < 4 && y > 1 && v && (!g.schema.children || g.schema.children.length === 0) && (t.dragState.parentNode = C, C.querySelector(".tiny-grid-tree-wrapper").innerHTML = '<i class="tiny-grid-tree__node-btn tiny-grid-icon__caret-right"></i>'), t.dragState.parentNode && t.dragState.parentNode.getAttribute("data-rowid") !== C.getAttribute("data-rowid") && (t.dragState.parentNode.querySelector(".tiny-grid-tree-wrapper").innerHTML = "", t.dragState.parentNode = null);
    };
    return G(
      () => c.isLock,
      (e) => {
        setTimeout(u, 1e3), t.isLock = e;
      }
    ), {
      checkElement: L,
      mouseover: x,
      mouseleave: I,
      showNode: A,
      state: t,
      getIcon: b,
      rowDropMove: O,
      gridRef: r,
      toggleTree: N,
      getClassName: l,
      PLUGIN_NAME: f,
      renderIconFn: (e, { isActive: o }) => e(oe(), {
        class: ["tiny-grid-tree__node-btn", { is__active: o }]
      })
    };
  }
}, ie = { class: "tree-wrap lowcode-scrollbar" }, le = ["schemaId", "type", "onMouseover", "onMouseleave", "onClick"], de = { class: "tree-content" }, ue = ["onMouseup"];
function ge(c, i, d, n, f, t) {
  const N = p("svg-button"), A = p("icon-eyeopen"), b = p("icon-eyeclose"), x = p("tiny-grid-column"), I = p("tiny-grid"), L = p("plugin-panel");
  return Y(), j(L, {
    class: "outlinebox",
    title: "大纲树",
    onClose: i[1] || (i[1] = (r) => c.$emit("close"))
  }, {
    header: w(() => {
      var r, u;
      return [
        h(N, {
          class: J(["item icon-sidebar", [((r = d.fixedPanels) == null ? void 0 : r.includes(n.PLUGIN_NAME.OutlineTree)) && "active"]]),
          tips: (u = d.fixedPanels) != null && u.includes(n.PLUGIN_NAME.OutlineTree) ? "解除固定面板" : "固定面板",
          onClick: i[0] || (i[0] = (l) => c.$emit("fixPanel", n.PLUGIN_NAME.OutlineTree)),
          name: "fixed"
        }, null, 8, ["class", "tips"])
      ];
    }),
    content: w(() => [
      _("div", ie, [
        h(I, {
          ref: "gridRef",
          data: n.state.pageSchema,
          "tree-config": { children: "children", expandAll: n.state.expandAll, renderIcon: n.renderIconFn },
          "show-header": !1,
          "highlight-hover-row": !1,
          "auto-resize": !0,
          "row-class-name": n.getClassName
        }, {
          default: w(() => [
            h(x, {
              field: "componentName",
              "tree-node": ""
            }, {
              default: w((r) => {
                var u;
                return [
                  _("span", {
                    class: "tree-box",
                    schemaId: (u = r.row) == null ? void 0 : u.id,
                    type: r.row.componentName,
                    onMouseover: (l) => n.mouseover(r.row, l),
                    onMouseleave: (l) => n.mouseleave(r.row, l),
                    onClick: (l) => n.checkElement(r.row)
                  }, [
                    _("span", de, [
                      _("span", null, K(r.row.componentName), 1)
                    ]),
                    k(_("span", {
                      class: "tree-handle",
                      onMouseup: (l) => n.showNode(r.row)
                    }, [
                      k(h(A, null, null, 512), [
                        [T, r.row.show]
                      ]),
                      k(h(b, null, null, 512), [
                        [T, !r.row.show]
                      ])
                    ], 40, ue), [
                      [T, !r.row.show]
                    ])
                  ], 40, le)
                ];
              }),
              _: 1
            })
          ]),
          _: 1
        }, 8, ["data", "tree-config", "row-class-name"])
      ])
    ]),
    _: 1
  });
}
const pe = /* @__PURE__ */ se(ae, [["render", ge], ["__scopeId", "data-v-676add94"]]), me = {
  id: "engine.plugins.outlinetree",
  title: "大纲树",
  type: "plugins",
  icon: "plugin-icon-tree",
  align: "top"
}, xe = {
  ...me,
  entry: pe
};
export {
  xe as default
};
